theory Deep
imports SimplC
uses
  ("source_import.ML")
keywords
  "source_sm" :: thy_decl and
  "source_exp" :: thy_decl and
begin

datatype prim_op = 
 OP_PLUS | OP_MINUS | OP_MUL | OP_DIV | 
 OP_EQUAL | OP_NEQ | OP_LEQ | OP_GEQ |
 OP_GREATER | OP_LESS

datatype pre_post_op =
  OP_INCR | OP_DECR

datatype ty =
    TVoid
  | TInt
  | TUInt
  | TChar
  | TPtr ty
  | TStruct string
  | TArray "ty"
  | TArrayN ty int

datatype var_kind = Param | Local | Global | GhostGlobal

type_synonym vctx = "(string \<times> (var_kind \<times> ty)) list"

datatype exp =
    EVar string
  | ECchar char
  | ECint int
  | ECuint int
  | ENull
  | EDeref exp
  | EAddr exp
  | EDot exp string
  | EArrow exp string
  | EIndex exp exp
  | EAssign exp exp
  | EPre pre_post_op exp
  | EPost pre_post_op exp
  | EPrim1 prim_op exp
  | EPrim2 prim_op exp exp
  | EFree exp
  | EFreeArray exp exp
  | ENew ty
  | ENewArray ty exp
  | EAnd exp exp
  | EOr exp exp
  | ECall string "exp list"

(*
datatype ghost =
  GAssign "string * isaterm"
*)
datatype sm =
    SSkip
  | SSeq sm sm
  | SExec exp
  | SBlock "(string * ty) list" sm
  | SIf exp sm sm
  | SWhile exp sm
  | SBreak
  | SContinue
  | SReturn exp
(*  | SGhost "vctx * ghost" *)

(*
fun export_aux :: "sm \<Rightarrow> bool"
where "export_aux _ = True"
*)

(*export_code export_aux in SML
  module_name Example file "example.ML"
*)

use "source_import.ML";

end