signature POS =
sig
 type t
 val dummy : t
 val mk : string -> int -> int -> t
 val fmt : t -> string
 val dummy_file : string

 exception ParseError of t * string

end

structure Pos : POS =
struct

type t = {
  file : string, 
  line : int,
  column : int
}

val dummy_file = "<no file>"

val dummy = {
  file = dummy_file,
  line = ~1,
  column = ~1
}

fun mk file line col =
 { file = file, line = line, column = col }

fun fmt { file, line, column } =
  if line = ~1 andalso column = ~1
  then "<unknown location>"
  else
      ((if file = dummy_file
        then "" else file)^
       Int.toString line ^ ":" ^ Int.toString column)

exception ParseError of t * string

end
