structure PrimTab =
struct

open Ast

fun prep_entry (nm,{args,res}) = 
  (nm,{primop =nm,args=args,res=res})

val tab = 
  (Symtab.make o map prep_entry)
   [
  ("prim_plus_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_minus_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_mul_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_div_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_mod_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_and_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_or_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_tilde_int",
   { args = [ TInt ], res = TInt }),
  ("prim_incr_int", 
   { args = [ TInt ], res = TInt }),
  ("prim_decr_int", 
   { args = [ TInt ], res = TInt }),
  ("prim_eq_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_neq_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_less_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_leq_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_greater_int",
   { args = [ TInt, TInt ], res = TInt }),
  ("prim_geq_int",
   { args = [ TInt, TInt ], res = TInt }),
                
  ("prim_plus_uint",
   { args = [ TUInt, TUInt ], res = TUInt }),
  ("prim_minus_uint",
  { args = [ TUInt, TUInt ], res = TUInt }),
  ("prim_mul_uint",
  { args = [ TUInt, TUInt ], res = TUInt }),
  ("prim_div_uint",
  { args = [ TUInt, TUInt ], res = TUInt }),
  ("prim_mod_uint",
  { args = [ TUInt, TUInt ], res = TUInt }),
  ("prim_and_uint",
   { args = [ TUInt, TUInt ], res = TUInt }),
  ("prim_or_uint",
   { args = [ TUInt, TUInt ], res = TUInt }),
  ("prim_tilde_uint",
   { args = [ TUInt ], res = TUInt }),
  ("prim_incr_uint", 
   { args = [ TUInt ], res = TUInt }),
  ("prim_decr_uint", 
   { args = [ TUInt ], res = TUInt }),
  ("prim_eq_uint",
   { args = [ TUInt, TUInt ], res = TInt }),
  ("prim_neq_uint",
   { args = [ TUInt, TUInt ], res = TInt }),
  ("prim_less_uint",
   { args = [ TUInt, TUInt ], res = TInt }),
  ("prim_leq_uint",
   { args = [ TUInt, TUInt ], res = TInt }),
  ("prim_greater_uint",
   { args = [ TUInt, TUInt ], res = TInt }),
  ("prim_geq_uint",
   { args = [ TUInt, TUInt ], res = TInt }),
 
  ("prim_plus_char",
   { args = [ TChar, TChar ], res = TInt  }),
  ("prim_minus_char",
   { args = [ TChar, TChar ], res = TInt  }),
  ("prim_mul_char",
   { args = [ TChar, TChar ], res = TInt  }),
  ("prim_div_char",
   { args = [ TChar, TChar ], res = TInt  }),
  ("prim_mod_char",
   { args = [ TChar, TChar ], res = TInt  }),
  ("prim_incr_char", 
   { args = [ TChar ], res = TChar }),
  ("prim_decr_char", 
   { args = [ TChar ], res = TChar }),
  ("prim_tilde_char",
   { args = [ TChar ], res = TChar }),
  ("prim_eq_char",
   { args = [ TChar, TChar ], res = TInt }),
  ("prim_neq_char",
   { args = [ TChar, TChar ], res = TInt }),
  ("prim_less_char",
   { args = [ TChar, TChar ], res = TInt }),
  ("prim_leq_char",
   { args = [ TChar, TChar ], res = TInt }),
  ("prim_greater_char",
   { args = [ TChar, TChar ], res = TInt }),
  ("prim_geq_char",
   { args = [ TChar, TChar ], res = TInt }),

  ("prim_not",
   { args = [ TInt ], res = TInt }),

  ("prim_plus_ptr",
   { args = [ (TPtr TVoid), TInt ], res = (TPtr TVoid) }),
  ("prim_plus_ptr_unsigned",
   { args = [ (TPtr TVoid), TUInt ], res = (TPtr TVoid) }),
  ("prim_minus_ptr",
   { args = [ (TPtr TVoid), (TPtr TVoid) ], res = TInt }),
  ("prim_incr_ptr",
   { args = [ (TPtr TVoid) ], res = (TPtr TVoid) }),
  ("prim_decr_ptr",
   { args = [ (TPtr TVoid) ], res = (TPtr TVoid) }),

  ("prim_eq_ptr",
   { args = [ (TPtr TVoid), (TPtr TVoid) ], res = TInt }),
  ("prim_neq_ptr",
   { args = [ (TPtr TVoid), (TPtr TVoid) ], res = TInt }),
  ("prim_less_ptr",
    { args = [ (TPtr TVoid), (TPtr TVoid) ], res = TInt }),
  ("prim_leq_ptr",
   { args = [ (TPtr TVoid), (TPtr TVoid) ], res = TInt }),
  ("prim_greater_ptr",
   { args = [ (TPtr TVoid), (TPtr TVoid) ], res = TInt }),
  ("prim_geq_ptr",
    { args = [ (TPtr TVoid), (TPtr TVoid) ], res = TInt }),
                
 (*
 ("prim_tilde_char",
  { args = [ TChar ], res = TChar,
    embed = fn [a] =>  to_Char (NOT (to_char a)) }),
 ("conv_int_char",
  { args = [ TInt ], res = TChar,
    embed = fn [a] =>  to_Char (scast (to_int a)) }),
 ("conv_char_int",
  { args = [ TChar ], res = TInt,
    embed = fn [a] =>  to_Int (scast (to_char a)) }),
 ("conv_uint_char",
  { args = [ TUInt ], res = TChar,
    embed = fn [a] =>  to_Char (scast (to_uint a)) }),
 ("conv_char_uint",
  { args = [ TChar ], res = TUInt,
    embed = fn [a] =>  to_UInt (scast (to_char a)) }),
*)

 ("cast_int_ptr",
  { args = [ TInt ], res = (TPtr TVoid) }),

 ("cast_ptr_int",
  { args = [ (TPtr TVoid) ], res = TInt }),
 ("cast_int_uint",
  { args = [ TInt ], res = TUInt }),
 ("cast_uint_int",
  { args = [ TUInt ], res = TInt })
]

fun get nm =
  case Symtab.lookup tab nm of
      NONE => error ("requested unknown operator "^nm)
    | SOME r => r

val indexed_tab =
   map (apsnd (map get))
   [
     (OP_EQUAL, [ "prim_eq_int", "prim_eq_uint", "prim_eq_char", "prim_eq_ptr" ]),
     (OP_NEQ, [ "prim_neq_int", "prim_neq_uint", "prim_neq_char", "prim_neq_ptr" ]),
     (OP_PLUS, [ "prim_plus_int", "prim_plus_uint", "prim_plus_char", 
                 "prim_plus_ptr", "prim_plus_ptr_unsigned" ]),
     (OP_MINUS, [ "prim_minus_int", "prim_minus_uint", "prim_minus_char", "prim_minus_ptr" ]),
     (OP_MUL, [ "prim_mul_int", "prim_mul_uint", "prim_mul_char" ]),
     (OP_DIV, [ "prim_div_int", "prim_div_uint", "prim_div_char" ]),
     (OP_MOD, [ "prim_mod_int", "prim_mod_uint", "prim_mod_char" ]),
     (OP_AND, [ "prim_and_int", "prim_and_uint" ]),
     (OP_OR, [ "prim_or_int", "prim_or_uint" ]),
     (OP_LESS, [  "prim_less_int", "prim_less_uint", "prim_less_char", "prim_less_ptr" ]),
     (OP_LEQ, [ "prim_leq_int", "prim_leq_uint", "prim_leq_char", "prim_leq_ptr" ]),
     (OP_GREATER, [ "prim_greater_int", "prim_greater_uint", "prim_greater_char", "prim_greater_ptr" ]),
     (OP_GEQ, [ "prim_geq_int", "prim_geq_uint", "prim_geq_char", "prim_geq_ptr" ]),

     (OP_NOT, [ "prim_not" ]),
     (OP_TILDE, [ "prim_tilde_int", "prim_tilde_char" ])
     (*
     ("@preincr", [ "prim_incr_int", "prim_incr_uint", "prim_incr_char", "prim_incr_ptr" ]),
     ("@postincr", [ "prim_incr_int", "prim_incr_uint", "prim_incr_char", "prim_incr_ptr" ]),
     ("@predecr", [ "prim_decr_int", "prim_decr_uint", "prim_decr_char", "prim_decr_ptr" ]),
     ("@postdecr", [ "prim_decr_int", "prim_decr_uint", "prim_decr_char", "prim_decr_ptr" ])
     *)
   ]

fun rename_vars i =
  map_aterms 
    (fn (Var((x,0),t)) => Var((x,i),t)
       | t => t)

fun match_types a f res =
  let fun repl NONE t = t
        | repl (SOME ty) (TPtr _) = TPtr ty
        | repl _ t = t
      fun loop [] [] ty =
        (case res of
            TPtr _ => SOME (map (repl ty) a, TPtr (the ty))
           | res => SOME (map (repl ty) a, res))
        | loop (x :: xs) (y :: ys) ty =
         (case x of
             TPtr s =>
             (case y of
                 TPtr _ => (* neglect the formal parameter, its TVoid *)
                  (case ty of
                      NONE => loop xs ys (SOME s)
                     | SOME r =>
                      if false (* orelse s <> r *)
                      then NONE
                      else loop xs ys ty)
                | _  => NONE)
            | _ =>
              if x <> y
              then NONE
              else loop xs ys ty)
  in 
      loop a f NONE
  end
                        

(**
  Encapsulate choice and typing of primitive operators here.
*)
fun choose exp prim (act : ty list) : (string * ty list * ty) =
  let val infos = 
         (the (AList.lookup (op=) indexed_tab prim)
             handle Option => error("Unknown operator "^PolyML.makestring prim))
      fun check {primop,args,res} =
        if length act <> length args
        then error ("wrong number of arguments in\n"^
                       PolyML.makestring exp)
        else (* check whether this matches *)
           case match_types act args res of
              NONE => NONE
             | SOME (args',t) => SOME(primop,args',t)
  in
      case map_filter check infos of
          [ r ] => r
        | [] => error ("Typing of operator "^PolyML.makestring prim^" failed in\n"^
                          (PolyML.makestring exp)^
                          "\nhave types ("^commas (map PolyML.makestring act)^")")
        | rs => error ("Ambiguous operator overloading "^commas (map #1 rs)^" in\n"^
                         (PolyML.makestring exp))
  end


end